﻿'--------------------------------------------------------------------------------------------------
'@Description This action invokes all functions from InvokeFunctions worksheet. Invoked functions are actually implemented in Functions.vbs script
'@Documentation Invoke all functions from InvokeFunctions worksheet
Option Explicit				' declare variables explicitly to distinct global and local variables
On Error Resume Next 		' go ahead, if wrong function name is typed in InvokeFunctions worksheet (default for test execution)
									' comment this statement for development and debugging

Dim cond,vars,params,rowcount,cnt,command,quote,delim,log_msg,res 	' variables for Action, can be moved to External library as Public
Dim varsa, parama
 							
' Insert code for testing here
'--------------------------------------------------------------------------------------------------
'--------------------------------------------------------------------------------------------------
quote = chr(34)
rowcount = DataTable.GetSheet("InvokeFunctions").GetRowCount			' for all rows in table
With DataTable
	crow=1   
	Do While crow <= rowcount													
		DataTable.SetCurrentRow (crow) 											' load parameters from table
		cond = DataTable("Condition", "InvokeFunctions")
		funct = DataTable("Function", "InvokeFunctions")
		vars = DataTable("Variables", "InvokeFunctions")
		params = replace(DataTable("Parameters", "InvokeFunctions"),quote,"")
		If funct <>"" Then															' if function is not empty and is not commented out
			If left(cond,1)="-" Then
				report_log cDONE, funct, " was skipped"						' to not wonder, what happens, log skipped functions also
			else	
				log_msg=" started"
				If cond<>"" And left(cond,1)<>":" Then log_msg=log_msg&", condition '"&cond&"' was true"
				If cond="" OR left(cond,1)=":" Then cond = True
				If eval (cond) Then													' if condition is true or is not set
					delim = " "
					varsa = split (vars,",")
					vars=""
		            For cnt = 0 to ubound(varsa)								' prepare list of parameters passed as variables (don't need quoting)
						If varsa(cnt)<>"" Then										' check for empty names (variabes should be always named)
							vars = vars&delim&varsa(cnt)
							If delim=" " Then delim = ", "			  			' set comma after parameter
						end if
					next
					parama = split (params,",")
					params = ""
					For cnt = 0 to ubound(parama)									' don't check for empty values, as parameters can be empty
						If isnumeric(parama(cnt)) OR StrComp(parama(cnt),"TRUE",vbTextCompare)=0 Or StrComp(parama(cnt),"FALSE",vbTextCompare)=0 Then	
							params = params&delim&parama(cnt)					' numeric/boolean and boolean values don't need quouting
						else																' string/date values should be quoted in double quotes
							params = params&delim&quote&parama(cnt)&quote
						End If
						If delim=" " Then delim = ", "
					next
					command = funct&" "&vars&params					  			' prepare command 
					test_status = cPASS												' reset execution status
					log_msg = vars&params&log_msg
					report_log cDONE, funct, log_msg								' log execution start
					If debug_on Then MsgBox command								' show invoked function, if debug_on is set to true
																							' note that functions invoked before init()and init itself will not be shown
					ExecuteGlobal (command)											' and invoke command
					log_msg = "Finished"
					If test_status = cPASS then log_msg = log_msg&" successfully"
					report_log test_status, funct, log_msg						' log execution finish
				Else 
					report_log cDONE, funct, funct&" was skiped because '"&cond&"' was false"	' log if function was not invoked due to false condition
				End If 
			End If
		End If
		crow=crow+1																		' go to the next row
	Loop
End with