' generates list of functions from WinRunner script file
' script assumes that each of function has explanation before and takes line that begins with "# PURPOSE:"
' and function definition starts with "public function"
Public strScriptPath

Call main   ' invoke function, to have exit possibility from scrit using exit sub

Sub main()
    strScriptPath = ".\"
    file_name = InputBox("Input script name", "File name", "Functions.vbs")
    If file_name = "" Then
        MsgBox "Script was canceled", vbInformation
        Exit Sub
    End If
    
    name_parts = Split(file_name, ".")
    output_file = InputBox("Output file name", "Files to store", name_parts(0) & "_list.txt")
    If output_file = "" Then
        MsgBox "Script was canceled", vbInformation
        Exit Sub
    End If
    
    Set fso = CreateObject("Scripting.FileSystemObject")        ' Create a FileSystemObject.
    
    Set DirFiles = fso.OpenTextFile(strScriptPath & "\" & file_name)
    Set DirFilet = fso.OpenTextFile(output_file, 2, True)
    Do While Not (DirFiles.atEndOfStream)
        Line = DirFiles.ReadLine
        start = 0 
        If Left(Line, 13) = "'@Description" Then desc = Mid(Line, 15)
        If Left(Line, 15) = "'@Documentation" Then doc = Mid(Line, 17)
        If InStr(1,Line,"Public Function",1)=1 Then start = 17
        If InStr(1,Line,"Public Sub",1)=1 Then start = 12
        If start >0 Then     	
            funct = Mid(Line,start)                 ' get function name and args
            LineOut = funct & Chr(9) & "'" & doc & ", " & desc
        DirFilet.WriteLine LineOut
        End If
    Loop
    
    MsgBox "List is stored in file:" & output_file, vbInformation, "Function list is ready"
    DirFiles.Close   ' Close file
    DirFilet.Close
End Sub

